from slack_sdk import WebClient
from slack_sdk.errors import SlackApiError

"""
Slack연동과 관련된 function list입니다.
"""

token = ("xoxb-2615293016641-2656423739733-lkBfSTIFPAQjjZR8CjoISuWT",)
username = "jerryjung@emart.com"
channel = "#emart_dt_report"
icon_emoji = ":large_blue_circle:"


def send(
    text="This is default text",
    blocks=None,
    dataframe=False,
):

    """
    Report channel에 Slack message를 보냅니다.
    ## Args
     text="This is default text",
     dataframe=True|False,
    ## Returns
        None
    ## Example
    ```python
        slack.send(text=text)
    ```
    """
    import requests

    if dataframe:
        from tabulate import tabulate

        text = "```" + tabulate(text, tablefmt="simple", headers="keys") + "```"
    headers = {
        "Content-Type": "application/json;charset=utf-8",
        "Authorization": f"Bearer {token}",
    }
    json_body = {
        "username": username,
        "channel": channel,
        "text": text,
        "blocks": blocks,
        "icon_emoji": icon_emoji,
    }

    r = requests.post(
        "https://www.slack.com/api/chat.postMessage",
        headers=headers,
        json=json_body,
    )
    r.raise_for_status()
    if not r.json()["ok"]:
        raise Exception(r.json())


def send_file(file_name=None):
    """
    Report channel에 file로 slack message를 보냅니다.
    ## Args
     file_name="./test.txt"
    ## Returns
        None
    ## Example
    ```python
        data = slack.send_file(file_name="./text.txt"])
    ```
    """
    client = WebClient(token=token)
    try:
        filepath = file_name
        response = client.files_upload(channels=channel, file=filepath)
        assert response["file"]  # the uploaded file
    except SlackApiError as e:
        # You will get a SlackApiError if "ok" is False
        assert e.response["ok"] is False
        assert e.response["error"]  # str like 'invalid_auth', 'channel_not_found'
        print(f"Got an error: {e.response['error']}")
